=encoding utf8

=head1 NAME

Mail::Box::Net - handle folders which are stored remote.

=head1 INHERITANCE

 Mail::Box::Net
   is a Mail::Box
   is a Mail::Reporter

 Mail::Box::Net is extended by
   Mail::Box::IMAP4
   Mail::Box::POP3

=head1 SYNOPSIS

  # Do not instantiate this object directly

=head1 DESCRIPTION

At the moment, this object is extended by

=over 4

=item * L<Mail::Box::POP3|Mail::Box::POP3>

Implements the POP3 protocol.

=item * L<Mail::Box::IMAP4|Mail::Box::IMAP4>

Implements the IMAP4 protocol.

=back

Extends L<"DESCRIPTION" in Mail::Box|Mail::Box/"DESCRIPTION">.

=head1 OVERLOADED

Extends L<"OVERLOADED" in Mail::Box|Mail::Box/"OVERLOADED">.

=over 4

=item overload: B<'""'> stringification

Inherited, see L<Mail::Box/"OVERLOADED">

=item overload: B<'@{}'> use as ARRAY

Inherited, see L<Mail::Box/"OVERLOADED">

=item overload: B<cmp> string comparison

Inherited, see L<Mail::Box/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Box|Mail::Box/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Box|Mail::Box/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Box/"Constructors">

 -Option           --Defined in     --Default
  access             Mail::Box        'r'
  body_delayed_type  Mail::Box        Mail::Message::Body::Delayed
  body_type          Mail::Box        Mail::Message::Body::Lines
  coerce_options     Mail::Box        +[]
  create             Mail::Box        false
  extract            Mail::Box        10240
  field_type         Mail::Box        undef
  fix_headers        Mail::Box        false
  folder             Mail::Box        '/'
  folderdir          Mail::Box        <network location>
  head_delayed_type  Mail::Box        Mail::Message::Head::Delayed
  head_type          Mail::Box        Mail::Message::Head::Complete
  keep_dups          Mail::Box        false
  lock_file          Mail::Box        undef
  lock_timeout       Mail::Box        1 hour
  lock_type          Mail::Box        'NONE'
  lock_wait          Mail::Box        10 seconds
  locker             Mail::Box        undef
  manager            Mail::Box        undef
  message_type       Mail::Box        <folder-class>::Message
  multipart_type     Mail::Box        Mail::Message::Body::Multipart
  password                            undef
  remove_when_empty  Mail::Box        <false>
  save_on_exit       Mail::Box        true
  server_name                         undef
  server_port                         undef
  trusted            Mail::Box        <false>
  username                            undef

=over 2

=item access => $mode

=item body_delayed_type => CLASS

=item body_type => CLASS|CODE

=item coerce_options => ARRAY

=item create => BOOLEAN

=item extract => INTEGER|CODE|METHOD|'LAZY'|'ALWAYS'

=item field_type => $class

=item fix_headers => BOOLEAN

=item folder => $name

=item folderdir => $directory

=item head_delayed_type => $class

=item head_type => $class

=item keep_dups => BOOLEAN

=item lock_file => $file

=item lock_timeout => $seconds

=item lock_type => $class|$name|\@names

=item lock_wait => $seconds

=item locker => $locker

=item manager => $manager

=item message_type => $class

=item multipart_type => CLASS

=item password => $password

The C<$password> which is required to contact the remote server.

=item remove_when_empty => BOOLEAN

=item save_on_exit => BOOLEAN

=item server_name => $host

The name of the C<$host> which contains the remote mail server.

=item server_port => $number

Port C<$number> in use by the server application.

=item trusted => BOOLEAN

=item username => $username

The username which is to be used for the remote server.

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Box|Mail::Box/"Attributes">.

=over 4

=item $obj-E<gt>B<fixHeaders>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<folderdir>( [$directory] )

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<isTrusted>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<removeEmpty>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<type>()

Inherited, see L<Mail::Box/"Attributes">

=back

=head2 The folder

Extends L<"The folder" in Mail::Box|Mail::Box/"The folder">.

=over 4

=item $obj-E<gt>B<addMessage>($message, %options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<addMessages>(@messages)

Inherited, see L<Mail::Box/"The folder">

=item $class-E<gt>B<appendMessages>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<close>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<copyTo>($folder, %options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<delete>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<organization>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<size>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<update>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<url>()

Inherited, see L<Mail::Box/"The folder">

=back

=head2 Folder flags

Extends L<"Folder flags" in Mail::Box|Mail::Box/"Folder flags">.

=over 4

=item $obj-E<gt>B<access>()

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<isModified>()

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<modified>( [BOOLEAN] )

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<writable>()

Inherited, see L<Mail::Box/"Folder flags">

=back

=head2 The messages

Extends L<"The messages" in Mail::Box|Mail::Box/"The messages">.

=over 4

=item $obj-E<gt>B<current>( [$number|$message|$message_id] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<find>($message_id)

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<findFirstLabeled>( $label, [BOOLEAN, [\@msgs]] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<message>( $index, [$message] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messageId>( $message_id, [$message] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messageIds>()

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messages>( <'ALL'|$range|'ACTIVE'|'DELETED'|$label| !$label|$filter> )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<nrMessages>(%options)

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<scanForMessages>($message, $message_ids, $timespan, $window)

Inherited, see L<Mail::Box/"The messages">

=back

=head2 Sub-folders

Extends L<"Sub-folders" in Mail::Box|Mail::Box/"Sub-folders">.

=over 4

=item $any-E<gt>B<listSubFolders>(%options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $any-E<gt>B<nameOfSubFolder>( $subname, [$parentname] )

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<openRelatedFolder>(%options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<openSubFolder>($subname, %options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $any-E<gt>B<topFolderWithMessages>()

Inherited, see L<Mail::Box/"Sub-folders">

=back

=head2 Internals

Extends L<"Internals" in Mail::Box|Mail::Box/"Internals">.

=over 4

=item $obj-E<gt>B<coerce>($message, %options)

Inherited, see L<Mail::Box/"Internals">

=item $any-E<gt>B<create>($folder, %options)

Create a new folder on the remote server.
Improves base, see L<Mail::Box/"Internals">

 -Option   --Defined in--Default
  folderdir  Mail::Box   undef

=over 2

=item folderdir => $directory

=back

=item $obj-E<gt>B<determineBodyType>($message, $head)

Inherited, see L<Mail::Box/"Internals">

=item $class-E<gt>B<foundIn>( [$foldername], %options )

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<lineSeparator>( [<STRING|'CR'|'LF'|'CRLF'>] )

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<locker>()

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<read>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<readMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<storeMessage>($message)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<toBeThreaded>($messages)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<toBeUnthreaded>($messages)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<updateMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<write>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<writeMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

=back

=head2 Other methods

Extends L<"Other methods" in Mail::Box|Mail::Box/"Other methods">.

=over 4

=item $any-E<gt>B<timespan2seconds>($time)

Inherited, see L<Mail::Box/"Other methods">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Box|Mail::Box/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Box|Mail::Box/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Box/"Cleanup">

=back

=head1 DETAILS

Extends L<"DETAILS" in Mail::Box|Mail::Box/"DETAILS">.

=head1 DIAGNOSTICS

=over 4

=item Error: Folder $name is opened read-only

You can not write to this folder unless you have opened the folder to
write or append with L<new(access)|Mail::Box/"Constructors">, or the C<force> option is set C<true>.
Cast by C<write()>

=item Warning: changes not written to read-only folder $name.

You have opened the folder read-only --which is the default set
by L<new(access)|Mail::Box/"Constructors">--, made modifications, and now want to close it.
Set L<close(force)|Mail::Box/"The folder"> if you want to overrule the access mode, or close
the folder with L<close(write)|Mail::Box/"The folder"> set to C<NEVER>.
Cast by C<close()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Error: copying failed for one message.

For some reason, for instance disk full, removed by external process, or
read-protection, it is impossible to copy one of the messages.  Copying will
proceed for the other messages.
Cast by C<copyTo()>

=item Error: destination folder $name is not writable.

The folder where the messages are copied to is not opened with write
access (see L<new(access)|Mail::Box/"Constructors">).  This has no relation with write permission
to the folder which is controlled by your operating system.
Cast by C<copyTo()>

=item Warning: different messages with id $msgid.

The message id is discovered more than once within the same folder, but the
content of the message seems to be different.  This should not be possible:
each message must be unique.
Cast by C<messageId()>

=item Warning: folder $name not deleted: not writable.

The folder must be opened with write access via L<new(access)|Mail::Box/"Constructors">, otherwise
removing it will be refused.  So, you may have write-access according to
the operating system, but that will not automatically mean that this
C<delete> method permits you to.  The reverse remark is valid as well.
Cast by C<delete()>

=item Error: invalid timespan '$span'.

The string does not follow the strict rules of the time span syntax which
is permitted as parameter.
Cast by C<timespan2seconds()>

=item Warning: message-id '$msgid' does not contain a domain.

According to the RFCs, message-ids need to contain a unique random part,
then an C<@>, and then a domain name.  This is made to avoid the creation
of two messages with the same id.  The warning emerges when the C<@> is
missing from the string.
Cast by C<messageId()>

=item Warning: the term 'hostname' is confusing wrt folder. You probably need 'server_name'.

Cast by C<new()>

=item Error: unknown value to folder->close(write => $when).

Cast by C<close()>

=item Error: you cannot add a message which is already part of a folder to a new one.  Please use moveTo or copyTo.

Cast by C<addMessage()>

=back

=head1 SEE ALSO

This module is part of Mail-Box version 4.02,
built on April 10, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

